## openscenegraph 3.6.4+dfsg1

=== CMakeLists.txt ===
#
# OpenSceneGraph CMake build file
#
SET(OPENSCENEGRAPH_MAJOR_VERSION 3)
SET(OPENSCENEGRAPH_MINOR_VERSION 6)
SET(OPENSCENEGRAPH_PATCH_VERSION 4)
SET(OPENSCENEGRAPH_SOVERSION 160)


# set to 0 when not a release candidate, non zero means that any generated
# git tags will be treated as release candidates of given number
SET(OPENSCENEGRAPH_RELEASE_CANDIDATE 9)
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.0 FATAL_ERROR)

if(COMMAND cmake_policy)
    # Works around warnings libraries linked against that don't
    # have absolute paths (e.g. -lpthreads)
    cmake_policy(SET CMP0003 NEW)

    # Works around warnings about escaped quotes in ADD_DEFINITIONS
    # statements.
    cmake_policy(SET CMP0005 NEW)

    # tell CMake to prefer CMake's own CMake modules when available
    # only available from cmake-2.8.4
    if("${CMAKE_VERSION}" VERSION_GREATER 2.8.3)
        cmake_policy(SET CMP0017 NEW)
    endif()

endif()

IF(APPLE)
  # Get OSX version in MAJOR.MINOR format
  EXECUTE_PROCESS(COMMAND sw_vers -productVersion
    OUTPUT_VARIABLE OSG_OSX_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE)
  STRING(REGEX REPLACE "^([0-9]+\\.[0-9]+).*$" "\\1"
    OSG_OSX_VERSION "${OSG_OSX_VERSION}")
ENDIF()

PROJECT(OpenSceneGraph)

# Set OSX architecture flags here, since they must be specified before
# creating the actual OSG project.
# Note that the CMAKE_OSX_* variables are not well documented in
# CMake 2.8, but they do officially exist.
# See https://cmake.org/Bug/view.php?id=14695#c34953
# Additionally, OSG_WINDOWING_SYSTEM is set here for OSX since its
# value is needed to find the correct version of OpenGL (X11 or Cocoa).

IF(ANDROID)
    SET(OSG_WINDOWING_SYSTEM "None" CACHE STRING "Windowing system type for graphics window creation; options: None.")
ELSEIF(WIN32 OR MINGW)
    SET(OSG_WINDOWING_SYSTEM "Win32" CACHE STRING "Windowing system type for graphics window creation; options: Win32 or None.")
ELSEIF(APPLE)
    # custom option to flag an iOS build
    OPTION(OSG_BUILD_PLATFORM_IPHONE "Enable IPhoneSDK Device support" OFF)

    IF(OSG_BUILD_PLATFORM_IPHONE)

        # set sdk and min versions
        SET (IPHONE_SDKVER "10.2" CACHE STRING "IOS SDK-Version")
        SET (IPHONE_VERSION_MIN "7.0" CACHE STRING "IOS minimum os version, use 7.0 or greater to get 64bit support")

        # get full path to sdk from requested versions
        SET (IPHONE_DEVROOT "/Applications/Xcode.app/Contents/Developer/Platforms/iPhoneOS.platform/Developer")
        SET (IPHONE_SDKROOT "${IPHONE_DEVROOT}/SDKs/iPhoneOS${IPHONE_SDKVER}.sdk")

        # optionally enable bitcode for the build
        SET (IPHONE_ENABLE_BITCODE "NO" CACHE STRING "IOS Enable Bitcode")

        # seamless toggle between device and simulator
        SET(CMAKE_XCODE_EFFECTIVE_PLATFORMS "-iphoneos;-iphonesimulator")

        # set deployment target to min version
        SET(CMAKE_XCODE_ATTRIBUTE_IPHONEOS_DEPLOYMENT_TARGET "${IPHONE_VERSION_MIN}" CACHE STRING "Deployment target for iOS" FORCE)

        # Set standard architectures
        SET(CMAKE_OSX_ARCHITECTURES "$(ARCHS_STANDARD)")

    ELSE()
        # OSX >= 10.5 uses Cocoa windowing system, otherwise Carbon
        IF(OSG_OSX_VERSION VERSION_LESS 10.5)
            SET(OSG_WINDOWING_SYSTEM "Carbon" CACHE STRING "Windowing system type for graphics window creation; options: Carbon, Cocoa, X11 or None.")
        ELSE()
            SET(OSG_WINDOWING_SYSTEM "Cocoa" CACHE STRING "Windowing system type for graphics window creation; options: Carbon, Cocoa, X11 or None.")
        ENDIF()

        # Set defaults for Universal Binaries. We want 32-bit Intel/PPC on 10.4
        # and 32/64-bit Intel/PPC on >= 10.5. Anything <= 10.3 doesn't support.
        # These are set the first time CMake is run, and can be changed by
        # the user at any time.
        IF(OSG_OSX_VERSION VERSION_GREATER 10.7)
            # 64 Bit Works, i386,ppc is not supported any more
            SET(CMAKE_OSX_ARCHITECTURES "x86_64" CACHE STRING "Build architectures for OSX")
            SET(CMAKE_OSX_DEPLOYMENT_TARGET "10.8" CACHE STRING "Target OSX version")
        ELSEIF(OSG_OSX_VERSION VERSION_EQUAL 10.7)
            # 64 Bit Works, PPC is not supported any more
            SET(CMAKE_OSX_ARCHITECTURES "i386;x86_64" CACHE STRING "Build architectures for OSX")
        ELSEIF(OSG_OSX_VERSION VERSION_GREATER 10.4)
            # 64-bit compiles are not supported with Carbon.
            SET(CMAKE_OSX_ARCHITECTURES "ppc;i386" CACHE STRING "Build architectures for OSX")
            SET(CMAKE_OSX_DEPLOYMENT_TARGET "10.5" CACHE STRING "Target OSX version")
        ELSEIF(OSG_OSX_VERSION VERSION_EQUAL 10.4)
            # 64-bit compiles are not supported with Carbon.
            SET(CMAKE_OSX_ARCHITECTURES "ppc;i386" CACHE STRING "Build architectures for OSX")
        ELSE()
            # No Universal Binary support and SDK detection is too unreliable.
            # Warn user and continue at their own peril.
            MESSAGE(WARNING "OSX 10.3 and earlier not supported.")
        ENDIF()
    ENDIF()
ELSE()
    SET(OSG_WINDOWING_SYSTEM "X11" CACHE STRING "Windowing system type for graphics window creation; options: X11 or None.")
ENDIF()


SET(OPENSCENEGRAPH_VERSION ${OPENSCENEGRAPH_MAJOR_VERSION}.${OPENSCENEGRAPH_MINOR_VERSION}.${OPENSCENEGRAPH_PATCH_VERSION})

SET(OSG_PLUGINS osgPlugins-${OPENSCENEGRAPH_VERSION})

SET(OSG_PLUGIN_PREFIX "")

IF (CYGWIN)
    SET(OSG_PLUGIN_PREFIX "cygwin_")
ENDIF()

IF(MINGW)
    SET(OSG_PLUGIN_PREFIX "mingw_")
ENDIF()


# We want to build SONAMES shared librariess
SET(OPENSCENEGRAPH_SONAMES TRUE)
SET(OPENTHREADS_SONAMES TRUE)

SET(OpenThreads_SOURCE_DIR ${OpenSceneGraph_SOURCE_DIR})

# We have some custom .cmake scripts not in the official distribution.
# Maybe this can be used override existing behavior if needed?
SET(CMAKE_MODULE_PATH "${OpenSceneGraph_SOURCE_DIR}/CMakeModules;${CMAKE_MODULE_PATH}")

# Change the default build type to Release
IF(NOT CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel." FORCE)
ENDIF(NOT CMAKE_BUILD_TYPE)


IF(ANDROID)
    INCLUDE(OsgAndroidMacroUtils)
ENDIF()

# Okay, here's the problem: On some platforms, linking against OpenThreads
# is not enough and explicit linking to the underlying thread library
# is also required (e.g. FreeBSD). But OpenThreads may be built with different
# backends (Pthreads, Sproc, Windows) so we don't know what the underlying
# thread library is because some platforms support multiple backends (e.g.
# IRIX supports Sproc and Pthreads). Linking all libraries won't work
# because the libraries may be incompatible.
# So the current solution is to attempt best guess linking and exempt certain
# cases. With IRIX, we're going to hope explicit linking to the underlying
# library is not necessary. We currently don't case for pthreads on Windows
# which might be an issue on things like Cygwin. This may need to be fixed.
IF(NOT ANDROID)
    FIND_PACKAGE(Threads)
ENDIF()
IF(CMAKE_SYSTEM MATCHES IRIX)
    # Erase CMAKE_THREAD_LIBS_INIT and hope it works
    SET(CMAKE_THREAD_LIBS_INIT "" CACHE INTERNAL "")
ENDIF()

OPTION(OSG_MAINTAINER "Enable OpenSceneGraph maintainer build methods, such as making git branches, tags, updating ChangeLog." OFF)
IF (OSG_MAINTAINER)

    SET(OPENSCENEGRAPH_BRANCH OpenSceneGraph-${OPENSCENEGRAPH_MAJOR_VERSION}.${OPENSCENEGRAPH_MINOR_VERSION})

    #
    # Provide target for tagging a release
    #
    SET(GITCOMMAND git)

    IF   (OPENSCENEGRAPH_RELEASE_CANDIDATE EQUAL 0)
        SET(RELEASE_NAME OpenSceneGraph-${OPENSCENEGRAPH_VERSION})
    ELSE()
        SET(RELEASE_NAME OpenSceneGraph-${OPENSCENEGRAPH_VERSION}-rc${OPENSCENEGRAPH_RELEASE_CANDIDATE})
    ENDIF()

    SET(RELEASE_MESSAGE "Release ${RELEASE_NAME}")
    SET(BRANCH_MESSAGE "Branch ${OPENSCENEGRAPH_BRANCH}")


    ADD_CUSTOM_TARGET(tag-test
        COMMAND echo ${GITCOMMAND} tag -a ${RELEASE_NAME} -m ${RELEASE_MESSAGE}
        COMMAND echo ${GITCOMMAND} push origin ${RELEASE_NAME}
    )

    ADD_CUSTOM_TARGET(tag-run
        COMMAND ${GITCOMMAND} tag -a ${RELEASE_NAME} -m ${RELEASE_MESSAGE}
        COMMAND ${GITCOMMAND} push origin ${RELEASE_NAME}
    )

    ADD_CUSTOM_TARGET(branch-test
        COMMAND echo ${GITCOMMAND} branch ${OPENSCENEGRAPH_BRANCH}
        COMMAND echo ${GITCOMMAND} push origin ${OPENSCENEGRAPH_BRANCH}
    )

    ADD_CUSTOM_TARGET(branch-run
        COMMAND ${GITCOMMAND} branch ${OPENSCENEGRAPH_BRANCH}
        COMMAND ${GITCOMMAND} push origin ${OPENSCENEGRAPH_BRANCH}
    )

    #
    # Provide target for generating ChangeLog
    #
    SET(GITLOGFORMAT "%aD%nAuthor : %an%n%s%b%n")
    SET(GENERATELOGS git log --pretty=format:${GITLOGFORMAT})

    ADD_CUSTOM_TARGET(ChangeLog
        COMMAND ${GENERATELOGS} > ChangeLog
    )

ENDIF(OSG_MAINTAINER)

IF(NOT ANDROID)
IF(APPLE)

    IF(OSG_BUILD_PLATFORM_IPHONE)

        # set the sdk path as our sysroot, if we set this before the project is defined cmake fails to build its test program
        SET(CMAKE_OSX_SYSROOT "${IPHONE_SDKROOT}" CACHE STRING "System root for iOS" FORCE)

        # Set the path to OpenGL library
        SET(OPENGL_gl_LIBRARY "${IPHONE_SDKROOT}/System/Library/Frameworks/OpenGLES.framework")

    ELSE ()
        FIND_LIBRARY(CARBON_LIBRARY Carbon)
        FIND_LIBRARY(COCOA_LIBRARY Cocoa)

        # Apple OS X: Find OpenGL and AGL based on OSG_WINDOWING_SYSTEM
        # This is the accepted way of finding X11/OpenGL on OSX, as
        # documented in CMake's FindOpenGL module.
        # Note that without this check, libosg would use Cocoa/OpenGL but
        # libosgViewer would use X11/OpenGL, which causes compatibility
        # issues for applications using OSG.
        UNSET(OPENGL_gl_LIBRARY CACHE)
        UNSET(OPENGL_INCLUDE_DIR CACHE)
        IF(OSG_WINDOWING_SYSTEM STREQUAL "X11")
          FIND_PACKAGE(X11)
          IF(NOT X11_FOUND)
            MESSAGE(FATAL_ERROR "OSG_WINDOWING_SYSTEM is X11, but no X11 installation was found. Please make sure X11 is properly installed.")
          ENDIF()

          # Use X11 version of OpenGL as seed for CMake FindOpenGL
          GET_FILENAME_COMPONENT(X11LIBDIR ${X11_X11_LIB} DIRECTORY)
          FIND_LIBRARY(OPENGL_gl_LIBRARY GL PATHS ${X11LIBDIR} DOC "OpenGL lib for OSX" NO_DEFAULT_PATH)
          SET(OPENGL_INCLUDE_DIR ${X11_INCLUDE_DIR} CACHE PATH "Include for OpenGL on OSX" FORCE)

        ELSEIF(OSG_WINDOWING_SYSTEM STREQUAL "Carbon")
          # AGL needed for Carbon windowing systems
          FIND_LIBRARY(AGL_LIBRARY AGL)
        ENDIF()

        FIND_PACKAGE(OpenGL)
        FIND_PACKAGE(EGL)
    ENDIF ()

    OPTION(OSG_COMPILE_FRAMEWORKS "compile frameworks instead of dylibs (experimental)" OFF)
    SET(OSG_COMPILE_FRAMEWORKS_INSTALL_NAME_DIR "@executable_path/../Frameworks" CACHE STRING "install name dir for compiled frameworks")
ELSE()
    # Non-Apple: Find OpenGL
    FIND_PACKAGE(OpenGL)
    FIND_PACKAGE(EGL)
ENDIF()
ENDIF()





IF(UNIX AND NOT ANDROID)
    # Not sure what this will do on Cygwin and Msys
    # Also, remember OS X X11 is a user installed option so it may not exist.
    FIND_PACKAGE(X11)
    # Some Unicies need explicit linkage to the Math library or the build fails.
    FIND_LIBRARY(MATH_LIBRARY m)

    FIND_LIBRARY(DL_LIBRARY dl)
    IF(NOT DL_LIBRARY)
        SET(DL_LIBRARY "") # change from NOTFOUND to empty when passed to linker
    ENDIF()

    IF( CMAKE_SYSTEM MATCHES "Linux" )
        FIND_LIBRARY( RT_LIBRARY rt )
    ENDIF( CMAKE_SYSTEM MATCHES "Linux" )

ENDIF()


# Make the headers visible to everything
IF(NOT ${PROJECT_BINARY_DIR} EQUAL ${PROJECT_SOURCE_DIR})
   INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include)
ENDIF()

INCLUDE_DIRECTORIES(${OpenSceneGraph_SOURCE_DIR}/include/)

INCLUDE_DIRECTORIES(SYSTEM ${OPENGL_INCLUDE_DIR})

# Common global definitions

=== examples/CMakeLists.txt ===
#######################################################
# this are setting used in SETUP_EXAMPLE macro
#######################################################
SET(TARGET_DEFAULT_PREFIX "example_")
SET(TARGET_DEFAULT_LABEL_PREFIX "Examples")

SET(TARGET_COMMON_LIBRARIES
    OpenThreads
    osg
    osgDB
    osgUtil
    osgGA
    osgViewer
    osgText
)

IF(ANDROID)
    # ADD_SUBDIRECTORY(osgandroidsimple)
ELSE(ANDROID)

IF(DYNAMIC_OPENSCENEGRAPH)

    ADD_SUBDIRECTORY(osgsimpleMDI)
    ADD_SUBDIRECTORY(osg2cpp)
    ADD_SUBDIRECTORY(osganalysis)
    ADD_SUBDIRECTORY(osganimate)
    ADD_SUBDIRECTORY(osgatomiccounter)
    ADD_SUBDIRECTORY(osgautocapture)
    ADD_SUBDIRECTORY(osgautotransform)
    ADD_SUBDIRECTORY(osgbillboard)
    ADD_SUBDIRECTORY(osgblenddrawbuffers)
    ADD_SUBDIRECTORY(osgblendequation)
    ADD_SUBDIRECTORY(osgcallback)
    ADD_SUBDIRECTORY(osgcamera)
    ADD_SUBDIRECTORY(osgcatch)
    ADD_SUBDIRECTORY(osgclip)
    ADD_SUBDIRECTORY(osgcompositeviewer)
    ADD_SUBDIRECTORY(osgcopy)
    ADD_SUBDIRECTORY(osgcubemap)
    ADD_SUBDIRECTORY(osgdeferred)
    ADD_SUBDIRECTORY(osgcluster)
    ADD_SUBDIRECTORY(osgdatabaserevisions)
    ADD_SUBDIRECTORY(osgdepthpartition)
    ADD_SUBDIRECTORY(osgdepthpeeling)
    ADD_SUBDIRECTORY(osgdrawinstanced)
    ADD_SUBDIRECTORY(osgdistortion)
    ADD_SUBDIRECTORY(osgfadetext)
    ADD_SUBDIRECTORY(osgfont)
    ADD_SUBDIRECTORY(osgforest)
    ADD_SUBDIRECTORY(osgfxbrowser)
    ADD_SUBDIRECTORY(osgoutline)
    ADD_SUBDIRECTORY(osggameoflife)
    ADD_SUBDIRECTORY(osggeometry)
    ADD_SUBDIRECTORY(osggeometryshaders)
    ADD_SUBDIRECTORY(osghangglide)
    ADD_SUBDIRECTORY(osghud)
    ADD_SUBDIRECTORY(osgimagesequence)
    ADD_SUBDIRECTORY(osgintersection)
    ADD_SUBDIRECTORY(osgkdtree)
    ADD_SUBDIRECTORY(osgkeyboard)
    ADD_SUBDIRECTORY(osgkeyboardmouse)
    ADD_SUBDIRECTORY(osgkeystone)
    ADD_SUBDIRECTORY(osglauncher)
    ADD_SUBDIRECTORY(osglight)
    ADD_SUBDIRECTORY(osglightpoint)
    ADD_SUBDIRECTORY(osglogicop)
    ADD_SUBDIRECTORY(osglogo)
    ADD_SUBDIRECTORY(osggpucull)
    ADD_SUBDIRECTORY(osggpx)
    ADD_SUBDIRECTORY(osggraphicscost)
    ADD_SUBDIRECTORY(osgmanipulator)
    ADD_SUBDIRECTORY(osgimpostor)
    ADD_SUBDIRECTORY(osgmovie)
    ADD_SUBDIRECTORY(osgmultiplemovies)
    ADD_SUBDIRECTORY(osgmultiplerendertargets)
    ADD_SUBDIRECTORY(osgmultitexture)
    ADD_SUBDIRECTORY(osgmultitexturecontrol)
    ADD_SUBDIRECTORY(osgmultitouch)
    ADD_SUBDIRECTORY(osgmultiviewpaging)
    ADD_SUBDIRECTORY(osgobjectcache)
    ADD_SUBDIRECTORY(osgoccluder)
    ADD_SUBDIRECTORY(osgocclusionquery)
    ADD_SUBDIRECTORY(osgoit)
    ADD_SUBDIRECTORY(osgoscdevice)
    ADD_SUBDIRECTORY(osgpackeddepthstencil)
    ADD_SUBDIRECTORY(osgpagedlod)
    ADD_SUBDIRECTORY(osgparametric)
    ADD_SUBDIRECTORY(osgparticle)
    ADD_SUBDIRECTORY(osgparticleeffects)
    ADD_SUBDIRECTORY(osgparticleshader)
    ADD_SUBDIRECTORY(osgpick)
    ADD_SUBDIRECTORY(osgplanets)
    ADD_SUBDIRECTORY(osgpoints)
    ADD_SUBDIRECTORY(osgpointsprite)
    ADD_SUBDIRECTORY(osgposter)
    ADD_SUBDIRECTORY(osgprecipitation)
    ADD_SUBDIRECTORY(osgprerender)
    ADD_SUBDIRECTORY(osgprerendercubemap)
    ADD_SUBDIRECTORY(osgreflect)
    ADD_SUBDIRECTORY(osgrobot)
    ADD_SUBDIRECTORY(osgSSBO)
    ADD_SUBDIRECTORY(osgsampler)
    ADD_SUBDIRECTORY(osgscalarbar)
    ADD_SUBDIRECTORY(osgscribe)
    ADD_SUBDIRECTORY(osgsequence)
    ADD_SUBDIRECTORY(osgshaders)
    ADD_SUBDIRECTORY(osgshaderpipeline)
    ADD_SUBDIRECTORY(osgshadercomposition)
    ADD_SUBDIRECTORY(osgshadergen)
    ADD_SUBDIRECTORY(osgshadermultiviewport)
    ADD_SUBDIRECTORY(osgshaderterrain)
    # ADD_SUBDIRECTORY(osgshadercompositor)
    ADD_SUBDIRECTORY(osgshadow)
    ADD_SUBDIRECTORY(osgshape)
    ADD_SUBDIRECTORY(osgsharedarray)
    ADD_SUBDIRECTORY(osgsimpleshaders)
    ADD_SUBDIRECTORY(osgsimplifier)
    ADD_SUBDIRECTORY(osgsimulation)
    ADD_SUBDIRECTORY(osgsidebyside)
    ADD_SUBDIRECTORY(osgslice)
    ADD_SUBDIRECTORY(osgspacewarp)
    ADD_SUBDIRECTORY(osgspheresegment)
    ADD_SUBDIRECTORY(osgspotlight)
    ADD_SUBDIRECTORY(osgstereoimage)
    ADD_SUBDIRECTORY(osgstereomatch)
    ADD_SUBDIRECTORY(osgterrain)
    ADD_SUBDIRECTORY(osgthreadedterrain)
    ADD_SUBDIRECTORY(osgtransferfunction)
    ADD_SUBDIRECTORY(osgtext)
    ADD_SUBDIRECTORY(osgtext3D)
    ADD_SUBDIRECTORY(osgtexture1D)
    ADD_SUBDIRECTORY(osgtexture2D)
    ADD_SUBDIRECTORY(osgtexture2DArray)
    ADD_SUBDIRECTORY(osgtexture3D)
    ADD_SUBDIRECTORY(osgtexturerectangle)
    ADD_SUBDIRECTORY(osgtexturecompression)
    ADD_SUBDIRECTORY(osgthirdpersonview)
    ADD_SUBDIRECTORY(osgtransformfeedback)
    ADD_SUBDIRECTORY(osguniformbuffer)
    ADD_SUBDIRECTORY(osguserstats)
    ADD_SUBDIRECTORY(osgvertexprogram)
    ADD_SUBDIRECTORY(osgvertexattributes)
    ADD_SUBDIRECTORY(osgvolume)
    ADD_SUBDIRECTORY(osgwindows)
    ADD_SUBDIRECTORY(osgvirtualprogram)
    ADD_SUBDIRECTORY(osganimationhardware)
    ADD_SUBDIRECTORY(osganimationtimeline)
    ADD_SUBDIRECTORY(osganimationnode)
    ADD_SUBDIRECTORY(osganimationmakepath)
    ADD_SUBDIRECTORY(osganimationmorph)
    ADD_SUBDIRECTORY(osganimationskinning)
    ADD_SUBDIRECTORY(osganimationsolid)
    ADD_SUBDIRECTORY(osganimationviewer)
    ADD_SUBDIRECTORY(osganimationeasemotion)
    ADD_SUBDIRECTORY(osgwidgetaddremove)
    ADD_SUBDIRECTORY(osgwidgetbox)
    ADD_SUBDIRECTORY(osgwidgetcanvas)
    ADD_SUBDIRECTORY(osgwidgetframe)
    ADD_SUBDIRECTORY(osgwidgetinput)
    ADD_SUBDIRECTORY(osgwidgetlabel)
    ADD_SUBDIRECTORY(osgwidgetmessagebox)
    ADD_SUBDIRECTORY(osgwidgetmenu)
    ADD_SUBDIRECTORY(osgwidgetnotebook)
    ADD_SUBDIRECTORY(osgwidgetperformance)
    ADD_SUBDIRECTORY(osgwidgetscrolled)
    ADD_SUBDIRECTORY(osgwidgetshader)
    ADD_SUBDIRECTORY(osgwidgetstyled)
    ADD_SUBDIRECTORY(osgwidgettable)
    ADD_SUBDIRECTORY(osgwidgetwindow)
    ADD_SUBDIRECTORY(osguserdata)
    # GL3/GL4 example
    ADD_SUBDIRECTORY(osgsimplegl3)
    ADD_SUBDIRECTORY(osgbindlesstext)
    IF(OSG_CPP_EXCEPTIONS_AVAILABLE)
        ADD_SUBDIRECTORY(osgunittests)
        ADD_SUBDIRECTORY(osgmemorytest)
    ENDIF()

    IF(NOT OSG_GL3_AVAILABLE)
        ADD_SUBDIRECTORY(osgfpdepth)
    ENDIF()

    IF(NOT OSG_GLES1_AVAILABLE AND NOT OSG_GLES2_AVAILABLE AND NOT OSG_GL3_AVAILABLE)
        ADD_SUBDIRECTORY(osgscreencapture)
        ADD_SUBDIRECTORY(osgmotionblur)
        ADD_SUBDIRECTORY(osgteapot)
    ENDIF()

    ADD_SUBDIRECTORY(osgphotoalbum)
    ADD_SUBDIRECTORY(osgtessellate)
    ADD_SUBDIRECTORY(osgtessellationshaders)
    ADD_SUBDIRECTORY(osgcomputeshaders)

    ADD_SUBDIRECTORY(osgpdf)

    IF   (SDL_FOUND)
        ADD_SUBDIRECTORY(osgviewerSDL)
    ENDIF(SDL_FOUND)

    IF   (GTKGL_FOUND)
        ADD_SUBDIRECTORY(osgviewerGTK)
    ENDIF(GTKGL_FOUND)

    IF   (FOX_FOUND)
        ADD_SUBDIRECTORY(osgviewerFOX)
    ENDIF(FOX_FOUND)

    IF   (wxWidgets_FOUND AND CMAKE_BUILD_TYPE)
        IF (${CMAKE_BUILD_TYPE} STREQUAL "Release")
            ADD_SUBDIRECTORY(osgviewerWX)
        ENDIF()
    ENDIF()

    IF   (FLTK_FOUND AND FLTK_GL_LIBRARY)
        ADD_SUBDIRECTORY(osgviewerFLTK)
    ENDIF()

    IF   (WIN32)

        OPTION(BUILD_MFC_EXAMPLE "Enable the build of the MFC Example" OFF)

        IF   (BUILD_MFC_EXAMPLE)
            ADD_SUBDIRECTORY(osgviewerMFC)
        ENDIF(BUILD_MFC_EXAMPLE)

    ENDIF(WIN32)

    IF   (APPLE)
        ADD_SUBDIRECTORY(osgviewerCocoa)
    ENDIF(APPLE)

    IF(DIRECTINPUT_FOUND)
       ADD_SUBDIRECTORY(osgdirectinput)
    ENDIF(DIRECTINPUT_FOUND)

    IF   (LIBVNCSERVER_FOUND)
        ADD_SUBDIRECTORY(osgvnc)
    ENDIF(LIBVNCSERVER_FOUND)

    #to add subject to find socket#ADD_SUBDIRECTORY(osgcluster)

ELSE(DYNAMIC_OPENSCENEGRAPH)
    #needed on win32 or the linker get confused by _declspec declarations
    ADD_DEFINITIONS(-DOSG_LIBRARY_STATIC)

    IF(OSG_BUILD_PLATFORM_IPHONE)
        ADD_SUBDIRECTORY(osgviewerIPhone)
    ELSE()
        ADD_SUBDIRECTORY(osgstaticviewer)
    ENDIF()

ENDIF(DYNAMIC_OPENSCENEGRAPH)

ENDIF(ANDROID)

=== examples/osgclip/CMakeLists.txt ===
#this file is automatically generated

SET(TARGET_SRC osgclip.cpp )
SET(TARGET_ADDED_LIBRARIES osgText )

#### end var setup  ###
SETUP_EXAMPLE(osgclip)

=== examples/osgcomputeshaders/CMakeLists.txt ===
SET(TARGET_SRC osgcomputeshaders.cpp)
SETUP_EXAMPLE(osgcomputeshaders)

=== examples/osgdepthpartition/CMakeLists.txt ===
SET(TARGET_SRC osgdepthpartition.cpp )

#### end var setup  ###
SETUP_EXAMPLE(osgdepthpartition)

=== examples/osggpucull/CMakeLists.txt ===
SET(TARGET_SRC 
  ShapeToGeometry.cpp
  AggregateGeometryVisitor.cpp
  osggpucull.cpp
)

SET(TARGET_H
  ShapeToGeometry.h
  AggregateGeometryVisitor.h
  GpuCullShaders.h
)

#### end var setup  ###
SETUP_EXAMPLE(osggpucull)

=== examples/osghud/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC osghud.cpp )
SET(TARGET_ADDED_LIBRARIES osgManipulator )
#### end var setup  ###
SETUP_EXAMPLE(osghud)

=== examples/osglightpoint/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC osglightpoint.cpp )
SET(TARGET_ADDED_LIBRARIES osgSim )
#### end var setup  ###
SETUP_EXAMPLE(osglightpoint)

=== examples/osgmotionblur/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC osgmotionblur.cpp )
#### end var setup  ###
SETUP_EXAMPLE(osgmotionblur)

=== examples/osgsequence/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC osgsequence.cpp )
#### end var setup  ###
SETUP_EXAMPLE(osgsequence)

=== examples/osgsidebyside/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC osgsidebyside.cpp)
SET(TARGET_ADDED_LIBRARIES osgSim ) 
#### end var setup  ###
SETUP_EXAMPLE(osgsidebyside)

=== examples/osgsimplifier/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC osgsimplifier.cpp )
#### end var setup  ###
SETUP_EXAMPLE(osgsimplifier)

=== debian/changelog ===
openscenegraph (3.6.4+dfsg1-3build2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 10 Feb 2020 08:14:28 +0100

openscenegraph (3.6.4+dfsg1-3build1) focal; urgency=medium

  * No-change rebuild for gdal soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 14 Jan 2020 14:31:36 +0000

openscenegraph (3.6.4+dfsg1-3) unstable; urgency=medium

  * Patch: make osg consider ffmpeg for opening video files.  Thanks Arnab
    Rana for reporting (Closes: #945598).

 -- Alberto Luaces Fernández <aluaces@udc.es>  Thu, 05 Dec 2019 12:25:58 +0100

openscenegraph (3.6.4+dfsg1-2) unstable; urgency=medium

  * Address the compilation warnings about risky implicitly defined copy
    constructors and operators.

 -- Alberto Luaces Fernández <aluaces@udc.es>  Thu, 07 Nov 2019 18:18:48 +0100

openscenegraph (3.6.4+dfsg1-1) experimental; urgency=medium

  [ Alberto Luaces Fernández ]
  * New upstream release.
  * Dependency on Qt upgraded from version 4 to 5 (Closes: #875075).

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Thu, 17 Oct 2019 00:10:47 +0200

=== debian/control ===
Source: openscenegraph
Maintainer: Alberto Luaces Fernández <aluaces@udc.es>
Uploaders: Manuel A. Fernandez Montecelo <mafm@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               doxygen,
               help2man,
               libgif-dev,
               libjpeg-dev,
               libtiff-dev,
               lib3ds-dev,
               libfreetype6-dev,
               libpng-dev,
               libcoin-dev,
               libgdal-dev,
               libx11-dev,
               libxmu-dev,
               freeglut3-dev,
               libgl1-mesa-dev | libgl-dev,
               libxine2-dev,
               libavcodec-dev,
               libswscale-dev,
               libavdevice-dev,
               libavresample-dev,
               librsvg2-dev,
               libpoppler-glib-dev,
               liblua5.2-dev,
               libcollada-dom2.4-dp-dev,
               libboost-filesystem-dev
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/openscenegraph-team/openscenegraph-3.2
Vcs-Git: https://salsa.debian.org/openscenegraph-team/openscenegraph-3.2.git
Homepage: http://www.openscenegraph.org/

Package: libopenthreads-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
         libopenthreads21 (= ${binary:Version})
Description: Object-Oriented (OO) thread interface for C++, development files
 This library is intended to provide a minimal & complete Object-Oriented (OO)
 thread interface for C++ programmers, used primarily in OpenSceneGraph.  It is
 loosely modeled on the Java thread API, and the POSIX Threads standards.
 .
 This package contains the development headers.

Package: libopenthreads21
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Object-Oriented (OO) thread interface for C++, shared libs
 This library is intended to provide a minimal & complete Object-Oriented (OO)
 thread interface for C++ programmers, used primarily in OpenSceneGraph.  It is
 loosely modeled on the Java thread API, and the POSIX Threads standards.
 .
 This package contains the shared libraries.

Package: libopenscenegraph-dev
Architecture: any
Section: libdevel
Depends: ${misc:Depends},
         libopenthreads-dev,
         libgl1-mesa-dev | libgl-dev,
         libgles2-mesa-dev,
         libglu-dev,
         libopenscenegraph160 (= ${binary:Version})
Suggests: openscenegraph-doc,
          openscenegraph-examples
Conflicts: libopenscenegraph-dev, libopenscenegraph-3.4-dev
Description: 3D scene graph, development files
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains the development headers.

Package: libopenscenegraph160
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: 3D scene graph, shared libs
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains the shared libraries.

Package: openscenegraph-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Description: 3D scene graph, documentation
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains the documentation.

Package: openscenegraph
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: openscenegraph
Description: 3D scene graph, utilities and examples (binaries)
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains utilities and examples (binaries).

Package: openscenegraph-examples
Architecture: all
Depends: ${misc:Depends}
Conflicts: openscenegraph-examples
Description: 3D scene graph, examples (sources)
 A portable, high level graphics toolkit for the development of high performance
 graphics applications such as flight simulators, games, virtual reality or
 scientific visualization.  Providing an object orientated framework on top of
 OpenGL, it frees the developer from implementing and optimizing low level
 graphics calls, and provide many additional utilities for rapid development of
 graphics applications.
 .
 This package contains examples (sources).

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export DH_OPTIONS=-v

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# At the moment, CMake discards CPPFLAGS, so we have to add its value
# to C{,XX}FLAGS variables

CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

%:
	dh $@ --buildsystem cmake --parallel

# Use override_dh_* targets to customize this.

CFLAGS := ${CFLAGS} ${ARCH_C_FLAGS}
CXXFLAGS := ${CXXFLAGS} ${ARCH_CXX_FLAGS}

LDFLAGS += -Wl,--as-needed

GRAB_VERSION_COMMAND := sed -n '1s~[^(]*(\(.*\)-.*).*~\1~p' debian/changelog | sed  's~+dfsg.*~~'
VERSION := $(shell $(GRAB_VERSION_COMMAND))
TARBALL_NAME := OpenSceneGraph-$(VERSION).tar.gz

# Get soname from the source code
SONAME_VERSION:=$(shell perl -wne '/OPENSCENEGRAPH_SOVERSION\s+(\d+)/ and print $$1;' CMakeLists.txt)

debian/libopenscenegraph$(SONAME_VERSION).lintian-overrides:
	sed -e 's/@V@/$(SONAME_VERSION)/g' debian/libopenscenegraph.lintian_overrides.in > $@

get-orig-source:
	dh_testdir
	wget --directory-prefix=.. https://github.com/openscenegraph/OpenSceneGraph/archive/$(TARBALL_NAME)

override_dh_clean:
	dh_testdir
	dh_testroot

	# Add here commands to clean up after the build process.
	rm -fr build
	rm -f ${MANPAGES} 
	rm -fr html
	rm -f doxygen_sqlite3.db
	rm -f debian/libopenscenegraph$(SONAME_VERSION).lintian-overrides

	dh_clean 

MANPAGES = \
	${MANAPPLICATIONS} \
	${MANEXAMPLES}

MANAPPLICATIONS = \
	osgviewer.1 \
	osgconv.1 \
	osgversion.1 \
	osgfilecache.1 \
	osgarchive.1 \
	osg2cpp.1

MANEXAMPLES = \
	osganimate.1 \
	osganimationhardware.1 \
	osganimationmakepath.1 \
	osganimationnode.1 \
	osganimationskinning.1 \
	osganimationsolid.1 \
	osganimationtimeline.1 \
	osganimationviewer.1 \
	osgautocapture.1 \
	osgautotransform.1 \
	osgbillboard.1 \
	osgblendequation.1 \
	osgbrowser.1 \
	osgcallback.1 \
	osgcamera.1 \
	osgcatch.1 \
	osgclip.1 \
	osgcluster.1 \
	osgcompositeviewer.1 \
	osgcopy.1 \
	osgcubemap.1 \
	osgdelaunay.1 \
	osgdepthpartition.1 \
	osgdepthpeeling.1 \
	osgdistortion.1 \
	osgdrawinstanced.1 \
	osgfadetext.1 \
	osgfilecache.1 \
	osgfont.1 \
	osgforest.1 \
	osgfxbrowser.1 \
	osggameoflife.1 \
	osggeometry.1 \
	osggeometryshaders.1 \
	osghangglide.1 \
	osghud.1 \
	osgimagesequence.1 \
	osgimpostor.1 \
	osgintersection.1 \
	osgkdtree.1 \
	osgkeyboard.1 \
	osgkeyboardmouse.1 \
	osglauncher.1 \
	osglight.1 \
	osglightpoint.1 \
	osglogicop.1 \
	osglogo.1 \
	osgmanipulator.1 \
	osgmemorytest.1 \
	osgmotionblur.1 \
	osgmovie.1 \
	osgmultiplerendertargets.1 \
	osgmultitexture.1 \
	osgmultitexturecontrol.1 \
	osgoccluder.1 \
	osgocclusionquery.1 \
	osgpackeddepthstencil.1 \
	osgpagedlod.1 \
	osgparametric.1 \
	osgparticle.1 \
	osgparticleeffects.1 \
	osgpdf.1 \
	osgphotoalbum.1 \
	osgpick.1 \
	osgplanets.1 \
	osgpoints.1 \
	osgpointsprite.1 \
	osgprecipitation.1 \
	osgprerender.1 \
	osgprerendercubemap.1 \
	osgreflect.1 \
	osgrobot.1 \
	osgscalarbar.1 \
	osgscreencapture.1 \
	osgscribe.1 \
	osgsequence.1 \
	osgshaders.1 \
	osgshaderterrain.1 \
	osgshadow.1 \
	osgshape.1 \
	osgsharedarray.1 \
	osgsidebyside.1 \
	osgsimplifier.1 \
	osgsimulation.1 \
	osgslice.1 \
	osgspacewarp.1 \
	osgspheresegment.1 \
	osgspotlight.1 \
	osgstereoimage.1 \
	osgstereomatch.1 \
	osgteapot.1 \
	osgterrain.1 \
	osgtessellate.1 \
	osgtext.1 \
	osgtext3D.1 \
	osgtexture1D.1 \
	osgtexture2D.1 \
	osgtexture3D.1 \
	osgtexturerectangle.1 \
	osgthirdpersonview.1 \
	osgunittests.1 \
	osgvertexprogram.1 \
	osgviewerGLUT.1 \
	osgvolume.1 \
	osgwidgetaddremove.1 \
	osgwidgetbox.1 \
	osgwidgetcanvas.1 \
	osgwidgetframe.1 \
	osgwidgetinput.1 \
	osgwidgetlabel.1 \
	osgwidgetmenu.1 \
	osgwidgetmessagebox.1 \
	osgwidgetnotebook.1 \
	osgwidgetperformance.1 \
	osgwidgetscrolled.1 \
	osgwidgetshader.1 \
	osgwidgetstyled.1 \
	osgwidgettable.1 \
	osgwidgetwindow.1 \
	osgwindows.1 \
	osganalysis.1 \
	osganimationeasemotion.1 \
	osganimationmorph.1 \
	osgdatabaserevisions.1 \
	osgfpdepth.1 \
	osggpx.1 \
	osggraphicscost.1 \
	osgmultiviewpaging.1 \
	osgoit.1 \
	osgoutline.1 \
	osgparticleshader.1 \
	osgposter.1 \
	osgqfont.1 \
	osgshadercomposition.1 \
	osgshadergen.1 \
	osgtexturecompression.1 \
	osgthreadedterrain.1 \
	osguniformbuffer.1 \
	osguserstats.1 \
	osgvertexattributes.1 \
	osgviewerGTK.1 \
	osgviewerSDL.1 \
	osgvirtualprogram.1 \
	present3D.1 \
	osguserdata.1 \
	osgviewerWX.1 \
	osgatomiccounter.1 \
	osgcomputeshaders.1 \
	osgframerenderer.1 \
	osgkeystone.1 \
	osgmultiplemovies.1 \
	osgmultitouch.1 \
	osgoscdevice.1 \
	osgsimplegl3.1 \
	osgsimpleshaders.1 \
	osgtessellationshaders.1 \
	osgSSBO.1 \
	osgblenddrawbuffers.1 \
	osggpucull.1 \
	osgtexture2DArray.1 \
	osgtransferfunction.1 \
	osgtransformfeedback.1 \
	osgbindlesstext.1 \
	osgdeferred.1 \
	osgobjectcache.1 \
	osgsampler.1 \
	osgshadermultiviewport.1 \
	osgshaderpipeline.1 \
	osgsimpleMDI.1

override_dh_install-indep:
	dh_install -i -XCMakeLists.txt

override_dh_installman:
# Provably better done with --builddirectory= in the general options
# than specifying DEFAULT_BUILD_DIRECTORY.  From the sources I can see
# that always starts with "obj-"
	for man in ${MANAPPLICATIONS} ; do if ! [ -e debian/$$man ] ; then help2man -N --version-string="$(VERSION)" -S OpenSceneGraph obj-*/bin/$${man%.1} > $$man ; else cp debian/$$man .; fi; done
	for man in ${MANEXAMPLES} ; do rm -f $$man ; ln -s debian/osgexamples.1 $$man ; done
	dh_installman -p openscenegraph ${MANPAGES}

override_dh_auto_build-indep:
	mkdir -p html
	doxygen debian/Doxyfile-openscenegraph
# Use Debian's jquery.js
	rm -f html/openscenegraph/jquery.js
	find html -name "*.html" -print0 | xargs -0 perl -i -pe 's|src="jquery.js"|src="/usr/share/javascript/jquery/jquery.js"|'


override_dh_auto_configure: debian/libopenscenegraph$(SONAME_VERSION).lintian-overrides
	dh_auto_configure -- --debug-output \
		-DCMAKE_INSTALL_PREFIX:PATH=/usr \
		-DBUILD_OSG_EXAMPLES:BOOL=ON \
		-DLIB_POSTFIX="/${DEB_HOST_MULTIARCH}" \
		-DCMAKE_RELWITHDEBINFO_POSTFIX="" \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DOSG_USE_LOCAL_LUA_SOURCE:BOOL=OFF \

## openscenegraph 3.6.5%2Bdfsg1

=== examples/osggpx/CMakeLists.txt ===

SET(TARGET_SRC osggpx.cpp )

#### end var setup  ###
SETUP_EXAMPLE(osggpx)

=== examples/osgterrain/CMakeLists.txt ===
SET(TARGET_SRC
    osgterrain.cpp
)

SET(TARGET_ADDED_LIBRARIES osgTerrain osgFX)

#### end var setup  ###
SETUP_EXAMPLE(osgterrain)

=== src/osgPlugins/txf/CMakeLists.txt ===

SET(TARGET_SRC 
    ReaderWriterTXF.cpp
    TXFFont.cpp
)
SET(TARGET_H
    TXFFont.h
)
SET(TARGET_ADDED_LIBRARIES osgText )

#### end var setup  ###
SETUP_PLUGIN(txf)

=== src/osgWrappers/serializers/osgVolume/CMakeLists.txt ===
FILE(GLOB TARGET_SRC *.cpp)
FILE(GLOB TARGET_H *.h)

SET(TARGET_ADDED_LIBRARIES osgVolume )

#### end var setup  ###
SETUP_PLUGIN(osgvolume)

## openscenegraph 3.6.5+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,13 +3,13 @@
 #
 SET(OPENSCENEGRAPH_MAJOR_VERSION 3)
 SET(OPENSCENEGRAPH_MINOR_VERSION 6)
-SET(OPENSCENEGRAPH_PATCH_VERSION 4)
-SET(OPENSCENEGRAPH_SOVERSION 160)
+SET(OPENSCENEGRAPH_PATCH_VERSION 5)
+SET(OPENSCENEGRAPH_SOVERSION 161)
 
 
 # set to 0 when not a release candidate, non zero means that any generated
 # git tags will be treated as release candidates of given number
-SET(OPENSCENEGRAPH_RELEASE_CANDIDATE 9)
+SET(OPENSCENEGRAPH_RELEASE_CANDIDATE 0)
 set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE)
 set_property(GLOBAL PROPERTY USE_FOLDERS ON)
 
@@ -73,18 +73,19 @@
         SET (IPHONE_ENABLE_BITCODE "NO" CACHE STRING "IOS Enable Bitcode")
 
         # seamless toggle between device and simulator
-        SET(CMAKE_XCODE_EFFECTIVE_PLATFORMS "-iphoneos;-iphonesimulator")
+        SET(CMAKE_XCODE_EFFECTIVE_PLATFORMS "-iphoneos;-iphonesimulator" CACHE STRING "Xcode effective platforms for iOS")
 
         # set deployment target to min version
-        SET(CMAKE_XCODE_ATTRIBUTE_IPHONEOS_DEPLOYMENT_TARGET "${IPHONE_VERSION_MIN}" CACHE STRING "Deployment target for iOS" FORCE)
+        SET(CMAKE_XCODE_ATTRIBUTE_IPHONEOS_DEPLOYMENT_TARGET "${IPHONE_VERSION_MIN}" CACHE STRING "Xcode deployment target for iOS")
 
         # Set standard architectures
-        SET(CMAKE_OSX_ARCHITECTURES "$(ARCHS_STANDARD)")
+        SET(CMAKE_OSX_ARCHITECTURES "$(ARCHS_STANDARD)" CACHE STRING "Build architectures for iOS")
 
     ELSE()
         # OSX >= 10.5 uses Cocoa windowing system, otherwise Carbon
         IF(OSG_OSX_VERSION VERSION_LESS 10.5)
             SET(OSG_WINDOWING_SYSTEM "Carbon" CACHE STRING "Windowing system type for graphics window creation; options: Carbon, Cocoa, X11 or None.")
+			SET(OSG_WINDOWING_SYSTEM_CARBON ON INTERNAL "use Carbon (apple; 32 bit only)")
         ELSE()
             SET(OSG_WINDOWING_SYSTEM "Cocoa" CACHE STRING "Windowing system type for graphics window creation; options: Carbon, Cocoa, X11 or None.")
         ENDIF()
@@ -301,11 +302,3 @@
 
 # Make the headers visible to everything
 IF(NOT ${PROJECT_BINARY_DIR} EQUAL ${PROJECT_SOURCE_DIR})
-   INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include)
-ENDIF()
-
-INCLUDE_DIRECTORIES(${OpenSceneGraph_SOURCE_DIR}/include/)
-
-INCLUDE_DIRECTORIES(SYSTEM ${OPENGL_INCLUDE_DIR})
-
-# Common global definitions

=== applications/CMakeLists.txt ===
PROJECT(OSG_APPLICATIONS)

SET(OSGCORE_BUNDLED TRUE)

IF(NOT OSGCORE_BUNDLED)
    FIND_PACKAGE(OSGCORE)
    IF(OSGCORE_FOUND)
        INCLUDE(${OSGCORE_USE_FILE})
    ELSE()
        MESSAGE(ERROR "OSGCORE neeeded but NOT FOUND")
    ENDIF()
    SET(CMAKE_MODULE_PATH  ${PROJECT_SOURCE_DIR}/../../Macros)
ENDIF()
SET(OPENSCENEGRAPH_APPLICATION_DIR ${PROJECT_SOURCE_DIR})


SET(TARGET_DEFAULT_PREFIX "application_")
SET(TARGET_DEFAULT_LABEL_PREFIX "Applications")
SET(TARGET_COMMON_LIBRARIES 
        OpenThreads
	osg 
	osgDB 
	osgUtil
	osgGA
	osgViewer 
	osgText 
)

IF(DYNAMIC_OPENSCENEGRAPH)
    ADD_SUBDIRECTORY(osgviewer)
    ADD_SUBDIRECTORY(osgarchive)
    ADD_SUBDIRECTORY(osgconv)
    ADD_SUBDIRECTORY(osgfilecache)
    ADD_SUBDIRECTORY(osgversion)
    ADD_SUBDIRECTORY(present3D)
ELSE()
    # need to define this on win32 or linker cries about _declspecs
    ADD_DEFINITIONS(-DOSG_LIBRARY_STATIC)

    ADD_SUBDIRECTORY(osgversion)
    ADD_SUBDIRECTORY(present3D)
ENDIF()

=== examples/osgCMakeExample/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

SET(PROJECT_NAME osgCMakeExample)

PROJECT(${PROJECT_NAME})

FIND_PACKAGE(OpenThreads)
FIND_PACKAGE(osg)
FIND_PACKAGE(osgDB)
FIND_PACKAGE(osgUtil)
FIND_PACKAGE(osgGA)
FIND_PACKAGE(osgViewer)

SET(SOURCES
    main.cpp
)

INCLUDE_DIRECTORIES(${OPENTHREADS_INCLUDE_DIR} ${OSG_INCLUDE_DIR})

LINK_DIRECTORIES(${OSG_LIB_DIR})

ADD_EXECUTABLE(${PROJECT_NAME} ${SOURCES})

TARGET_LINK_LIBRARIES(${PROJECT_NAME} ${OSG_LIBRARIES} ${OSGVIEWER_LIBRARIES} ${OSGUTIL_LIBRARIES} ${OSGDB_LIBRARIES} ${OSGGA_LIBRARIES} ${OPENTHREADS_LIBRARIES})

=== examples/osganimationmorph/CMakeLists.txt ===
SET(TARGET_SRC osganimationmorph.cpp )
SET(TARGET_ADDED_LIBRARIES osgAnimation )
SETUP_EXAMPLE(osganimationmorph)

=== examples/osganimationtimeline/CMakeLists.txt ===
SET(TARGET_SRC osganimationtimeline.cpp )
SET(TARGET_ADDED_LIBRARIES osgAnimation )
SETUP_EXAMPLE(osganimationtimeline)

=== examples/osganimationviewer/CMakeLists.txt ===
SET(TARGET_SRC 
  AnimtkViewer.cpp
  AnimtkViewerKeyHandler.cpp
  AnimtkViewerGUI.cpp
  )
SET(TARGET_ADDED_LIBRARIES osgAnimation osgWidget)
SETUP_EXAMPLE(osganimationviewer)

=== examples/osgbindlesstext/CMakeLists.txt ===
SET(TARGET_SRC osgbindlesstext.cpp )
SETUP_EXAMPLE(osgbindlesstext)

=== examples/osgblendequation/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC osgblendequation.cpp )
SET(TARGET_ADDED_LIBRARIES osgGA )
#### end var setup  ###
SETUP_EXAMPLE(osgblendequation)

=== examples/osgcallback/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC osgcallback.cpp )
#### end var setup  ###
SETUP_EXAMPLE(osgcallback)

=== examples/osgcatch/CMakeLists.txt ===
#this file is automatically generated 


SET(TARGET_SRC osgcatch.cpp )
SET(TARGET_ADDED_LIBRARIES osgParticle )
#### end var setup  ###
SETUP_EXAMPLE(osgcatch)

=== examples/osgdatabaserevisions/CMakeLists.txt ===
SET(TARGET_SRC osgdatabaserevisions.cpp )

#### end var setup  ###
SETUP_EXAMPLE(osgdatabaserevisions)

=== examples/osgdeferred/CMakeLists.txt ===
SET(TARGET_SRC 
    osgdeferred.cpp
)

SET(TARGET_H
    osgdeferred.h
)

SET(TARGET_ADDED_LIBRARIES osgShadow)

#### end var setup  ###
SETUP_EXAMPLE(osgdeferred)

=== debian/changelog ===
openscenegraph (3.6.5+dfsg1-11build1) resolute; urgency=medium

  * No-change rebuild for libgdal37.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Thu, 30 Oct 2025 20:54:05 +0000

openscenegraph (3.6.5+dfsg1-11) unstable; urgency=medium

  * Updated minimum cmake policy version to 3.5 (Closes: 1113365)

 -- Alberto Luaces Fernández <aluaces@udc.es>  Mon, 29 Sep 2025 08:41:21 +0200

openscenegraph (3.6.5+dfsg1-10) unstable; urgency=medium

  * Update obsolete dependencies.
  * Update standards version to 4.7.0.
  * Remove duplicate copyright assignments.

 -- Alberto Luaces Fernández <aluaces@udc.es>  Wed, 29 Jan 2025 13:34:14 +0100

openscenegraph (3.6.5+dfsg1-9) unstable; urgency=medium

  * Update lua dependency. (Closes: 1050599)
  * Allow cross compiling from source avoiding runtime tests. Thanks to
    Helmut Grohne (Closes: 1086158)

 -- Alberto Luaces Fernández <aluaces@udc.es>  Mon, 06 Jan 2025 19:44:15 +0100

openscenegraph (3.6.5+dfsg1-8) unstable; urgency=medium

  * Drop ffmpeg dependency, since currently there is no upstream support
    for it.

 -- Alberto Luaces Fernández <aluaces@udc.es>  Mon, 24 Oct 2022 10:27:16 +0200

openscenegraph (3.6.5+dfsg1-7) unstable; urgency=medium

  [ Alberto Luaces ]
  * Added patch for spelling fixes submitted upstream.

  [ Debian Janitor ]
  Apply multi-arch hints.

  * libopenscenegraph-dev, libopenthreads-dev: Add Multi-Arch: same.
  * openscenegraph-doc, openscenegraph-examples: Add Multi-Arch: foreign.

 -- Alberto Luaces Fernández <aluaces@udc.es>  Mon, 09 Nov 2020 17:06:41 +0100

openscenegraph (3.6.5+dfsg1-6) unstable; urgency=low

  * Replace avresample by swresample.  No modifications are needed since
    it is not used directly in the code. (Closes: #971320)
  * Update Doxygen configuration file according to the warnings it issues.

 -- Alberto Luaces Fernández <aluaces@udc.es>  Tue, 29 Sep 2020 13:17:01 +0200

openscenegraph (3.6.5+dfsg1-5) unstable; urgency=low

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * debian/copyright: use spaces rather than tabs to start continuation lines.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Alberto Luaces Fernández <aluaces@udc.es>  Tue, 01 Sep 2020 16:57:29 +0200

openscenegraph (3.6.5+dfsg1-4) unstable; urgency=medium

  * Backported patch for reducing console verbosity.  Thanks Bret Curtis!
  * Upload only the source package to be able to migrate to testing
    (Closes: #961997).

 -- Alberto Luaces Fernández <aluaces@udc.es>  Thu, 04 Jun 2020 18:03:36 +0200

openscenegraph (3.6.5+dfsg1-3) unstable; urgency=medium

  * Re-upload with a signature from a non-expired key.

 -- Alberto Luaces Fernández <aluaces@udc.es>  Sun, 03 May 2020 19:31:09 +0200

openscenegraph (3.6.5+dfsg1-2) unstable; urgency=medium

  * Backport a patch from 3.6.6 to deal with malformed TGA files.  Thanks
    Bret Curtis!
  * Remove -Wl,--as-needed as per lintian recommendation.
  * Hardening flags are now set with dpkg-buildflags.
  * Move to unstable.

 -- Alberto Luaces Fernández <aluaces@udc.es>  Fri, 01 May 2020 13:12:04 +0200

openscenegraph (3.6.5+dfsg1-1) experimental; urgency=medium

  [ Alberto Luaces Fernández ]
  * xine plugin is not needed anymore.
  * New upstream version 3.6.5+dfsg1 (Closes: #945875).
  * Soname bumped for new version.
  * Discard ffmpeg patch, already in upstream.
  * Update to debhelper 12.  Some install files had to be adjusted.
  * Doxygen configuration file updated.
  * debian/rules: remove --parallel since it is now redundant.
  * Update policy to 4.5.0.
  * Update spelling fixes patch.

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Tue, 14 Apr 2020 23:50:53 +0200

=== debian/rules ===
--- 
+++ 
@@ -1,27 +1,15 @@
 #!/usr/bin/make -f
 
-# Uncomment this to turn on verbose mode.
-#export DH_VERBOSE=1
-#export DH_OPTIONS=-v
-
-DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
-
 # At the moment, CMake discards CPPFLAGS, so we have to add its value
-# to C{,XX}FLAGS variables
-
-CFLAGS += $(CPPFLAGS)
-CXXFLAGS += $(CPPFLAGS)
+# to C{,XX}FLAGS variables per https://wiki.debian.org/Hardening
+
+CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
+CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
+CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS) -Wno-overloaded-virtual
+LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)
 
 %:
-	dh $@ --buildsystem cmake --parallel
-
-# Use override_dh_* targets to customize this.
-
-CFLAGS := ${CFLAGS} ${ARCH_C_FLAGS}
-CXXFLAGS := ${CXXFLAGS} ${ARCH_CXX_FLAGS}
-
-LDFLAGS += -Wl,--as-needed
+	dh $@ --buildsystem cmake
 
 GRAB_VERSION_COMMAND := sed -n '1s~[^(]*(\(.*\)-.*).*~\1~p' debian/changelog | sed  's~+dfsg.*~~'
 VERSION := $(shell $(GRAB_VERSION_COMMAND))
@@ -43,12 +31,12 @@
 
 	# Add here commands to clean up after the build process.
 	rm -fr build
-	rm -f ${MANPAGES} 
+	rm -f ${MANPAGES}
 	rm -fr html
 	rm -f doxygen_sqlite3.db
 	rm -f debian/libopenscenegraph$(SONAME_VERSION).lintian-overrides
 
-	dh_clean 
+	dh_clean
 
 MANPAGES = \
 	${MANAPPLICATIONS} \
@@ -260,3 +248,4 @@
 		-DCMAKE_RELWITHDEBINFO_POSTFIX="" \
 		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
 		-DOSG_USE_LOCAL_LUA_SOURCE:BOOL=OFF \
+		-DCMAKE_POLICY_VERSION_MINIMUM=3.5 \

=== debian/watch ===
version=4
opts="dversionmangle=s/.dfsg\d+//, \
     filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%<project>-$1.tar.gz%" \
     https://github.com/openscenegraph/OpenSceneGraph/tags \
     (?:.*?/)?OpenSceneGraph-(3.6.[\d.]*)\.tar\.gz debian uupdate
